Codeforces Round #261 (Div. 2) E

2024-01-28 06:48
文章标签 codeforces round div 261

本文主要是介绍Codeforces Round #261 (Div. 2) E,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

E. Pashmak and Graph


        题意:一个带权有向图,没有重边,没有自环。求图的最长路径长度,使得该路径每一条边权都严格递增。

        思路:先排序,然后dp。dp[u]表示以u为起点的最长递增路径长度,len[u]表示以u为起点的最长递增路径的第一条边权。权值递减扫描所有边,状态转移:dp[u]=max(dp[u],dp[v]+1)(存在边uv且权w(u,v)<len(v))。但是这个题发现满足转移条件不能立即进行状态转移,因为有权相同的边,如果立即转移可能会影响这些边的转移。处理方法是用一个队列把能转移的边先存起来,直到扫描到权减小以后,一次性将他们全部转移。


#include <iostream>    
#include <stdio.h>    
#include <cmath>    
#include <algorithm>    
#include <iomanip>    
#include <cstdlib>    
#include <string>    
#include <memory.h>    
#include <vector>    
#include <queue>    
#include <stack>    
#include <map>  
#include <set>  
#include <ctype.h>    
#define INF 1000000
#define ll long long
#define min3(a,b,c) min(a,min(b,c))
#define max3(a,b,c) max(a,max(b,c))
#define MAXN 100010using namespace std;  struct edge{int u;int v;int w;
};edge E[600010];bool cmp(edge e1,edge e2){return e1.w<e2.w;
}int dp[300010];
int len[300010];queue<int> que;
queue<int> update;int main() {std::ios::sync_with_stdio(false);std::cin.tie(0);int n;//点 int m;//边 while(cin>>n>>m){memset(dp,0,sizeof(dp));for(int i=1;i<=n;i++)len[i]=INF;for(int i=1;i<=m;i++){cin>>E[i].u>>E[i].v>>E[i].w;}sort(E+1,E+m+1,cmp);int ans=0;for(int i=m;i>=1;i--){if(E[i].w!=E[i+1].w){//一次性转移 while(!que.empty()){int cur=que.front();que.pop();len[cur]=E[i+1].w;dp[cur]=max(dp[cur],update.front());update.pop();ans=max(ans,dp[cur]);}}if( dp[E[i].u]<dp[E[i].v]+1 && (E[i].w<len[E[i].v]) ){//存在队列中 update.push(dp[E[i].v]+1);que.push(E[i].u);}}while(!que.empty()){int cur=que.front();que.pop();dp[cur]=max(dp[cur],update.front());update.pop();ans=max(ans,dp[cur]);}cout<<ans<<endl;}return 0;
}


这篇关于Codeforces Round #261 (Div. 2) E的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/652804

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There